﻿var path;
var apikey = "?apikey=0";
var feedlist;
var timerID;
var timerTime = 10*1000;
var feedNames = [
  ["PhotoVoltaic Power", "#solarpv", " kW"],
  ["Total Power", "#totalpower", " kW"],
  ["State Of Charge", "#soc", "%"],
  ["Outdoor Temperature", "#outdoortemp", "°C"]
];

function contains(arr,v){
  return ~arr.indexOf(v);
}

function getData(){
  var feedIn = [];
  $.ajax({ url: path+"feed/list.json"+apikey, dataType: 'json', async: false, success: function(data) {feedIn = data;} });
  return feedIn;
}

function onUpdate(){
  if(timerID){
    clearTimeout(timerID);
  }
  var feedIn = getData();
  for(i in feedIn){
    for(j in feedNames){
      if(contains(feedIn[i]['name'], feedNames[j][0])){
        if(( feedIn[i]['time'] + 30 * 60 ) * 1000 < Date.now()){
          $(feedNames[j][1]).html("???"+feedNames[j][2]);
        }else{
          if(contains(feedNames[j][1], "soc")){
            var soc = (+(feedIn[i]['value']));
            if(soc > 1.0){
              soc = 1.0;
            }else if(soc < 0.0){
              soc = 0.0;
            }
            $(feedNames[j][1]).html((soc*100).toFixed(0) + feedNames[j][2]);
            updateBatteryNotification(soc);
          }else{
            $(feedNames[j][1]).html((+(feedIn[i]['value'])).toFixed(1) + feedNames[j][2]);
          }
        }
      }
    }
  }
  timerID = setTimeout(onUpdate, timerTime);
}

$(document).ready(function(){$('body').html($('div.span12:first').html());});

onUpdate();
