﻿// Declaring page global variables
var path;
var apikey = "apikey=0";
var feedlist;
var dropdownlists = [];
var searchFor = [];
var pieList = [];
var pieBool = false;
var colours = ["#0000FF","#00FF00","#FF0000","#FFFF00","#FF00FF","#00FFFF"
              ,"#FF6384","#FFCE56","#4BC0C0","#000000","#E7E9ED","#A633CC"];

function fillSearchForArray(){
//searchfor.push(["Del av feednamn",    "typ",  "enhet eller text",     "visningstyp"]);
  searchFor.push(["Total Power DC",     "text", "Elanvändning (kW)",    "raw"]);
  searchFor.push(["Total Power DC",     "min",  "kW",                   "raw"]);
  searchFor.push(["Total Power DC",     "max",  "kW",                   "raw"]);
  searchFor.push(["Total Power DC",     "mean", "kW",                   "raw"]);
  searchFor.push(["Total Power DC",     "",     "",                     "chart"]);
  return searchFor;
}

for (var i in fillSearchForArray()){
  draw_options(searchFor[i]);
}
if (dropdownlists.length == 0) draw_options();

function enableDisableRemBtn(){
  if (dropdownlists.length > 1){
    $('#remfeedbtn').attr('disabled',false);
  }else{
    $('#remfeedbtn').attr('disabled',true);
  }
}

  // --- Functions
function draw_options(searchForArr) { // It has been edited to add a feed dropdownlist
  searchForArr = (searchForArr || [undefined,undefined,undefined,undefined]);
  // Build options table html
  var options_html = "";//$("#box-options").html();
  options_html += "<div id='box-options" + (dropdownlists.length) + "'>";
  options_html += "<div class='input-prepend'><span class='add-on' style='width: 70px; text-align: right;'>Feed</span>";
  options_html += select_feed(searchForArr[0]);
  options_html += select_radio(searchForArr[1]);
  options_html += select_unit(searchForArr[2]);
  if (searchForArr[1] == "text" || searchForArr[1] == "list") {
    options_html += select_type();
  }else{
    options_html += select_type(searchForArr[3]);
  }
  options_html += "</div></div>";
  enableDisableRemBtn();
  //$('#box-options').html(options_html); // Don't use, better method using jQuery below
  $('#box-options').append(options_html);
}

// Remove feed dropdownlist
function remove_options() {
  //var options_html = $("#box-options").html();
  dropdownlists.pop();
  enableDisableRemBtn();
  //$('#box-options').html(options_html.split('<div id="box-options'+ (dropdownlists.length) +'">')[0]); // Don't use, better method using jQuery below
  $('#box-options'+dropdownlists.length).remove();
}

// Create a drop down select box with a list of feeds.
function select_feed(searchForString) {
  var feedgroups = [];
  var feedIn = [];
  $.ajax({ url: path+"feed/list.json?"+apikey, dataType: 'json', async: false, success: function(data) {feedIn = data;} });
  for (z in feedIn) {
    var group = (feedIn[z].tag === null ? "NoGroup" : feedIn[z].tag);
    if (group!="Deleted") {
      if (!feedgroups[group]) feedgroups[group] = [];
      feedgroups[group].push(feedIn[z]);
    }
  }
  var out = "<select id='feedid" + dropdownlists.length + "' class='options' otype='feed'>";
  dropdownlists[dropdownlists.length] = "feedid" + dropdownlists.length; // Adding feed dropdownlist id to page list
  for (z in feedgroups) {
    out += "<optgroup label='" + z + "'>";
    for (p in feedgroups[z]) {
      out += "<option value='" + feedgroups[z][p]['id'] + "' public='" + feedgroups[z][p]['public'] + "' " + (~feedgroups[z][p].name.indexOf(searchForString) ? " selected" : "") + ">" + feedgroups[z][p].id + ": " + feedgroups[z][p].name + "</option>";
    }
    out += "</optgroup>";
  }
  out += "</select>";
  return out;
}

// Adds radio buttons
function select_radio(valueString) {
  switch(valueString){
    case "max":
    case "min":
    case "mean":
    case "median":
    case "mode":
    case "range":
    case "list":
    case "text":
      break;
    default:
      valueString = "difference";
  }
  out = "<span class='add-on' style='text-align: right;'><p>";
  out += "<input type='radio' name='feedid" + (dropdownlists.length-1) + "radio' value='max'" + (valueString == "max" ? " checked" : "") + ">Max ";
  out += "<input type='radio' name='feedid" + (dropdownlists.length-1) + "radio' value='min'" + (valueString == "min" ? " checked" : "") + ">Min ";
  out += "<input type='radio' name='feedid" + (dropdownlists.length-1) + "radio' value='mean'" + (valueString == "mean" ? " checked" : "") + ">Genomsnitt ";
  out += "<input type='radio' name='feedid" + (dropdownlists.length-1) + "radio' value='median'" + (valueString == "median" ? " checked" : "") + ">Median ";
  out += "<input type='radio' name='feedid" + (dropdownlists.length-1) + "radio' value='mode'" + (valueString == "mode" ? " checked" : "") + ">Mode ";
  out += "<input type='radio' name='feedid" + (dropdownlists.length-1) + "radio' value='range'" + (valueString == "range" ? " checked" : "") + ">Omfång ";
  out += "<input type='radio' name='feedid" + (dropdownlists.length-1) + "radio' value='difference'" + (valueString == "difference" ? " checked" : "") + ">Skillnad ";
  out += "<input type='radio' name='feedid" + (dropdownlists.length-1) + "radio' value='list'" + (valueString == "list" ? " checked" : "") + ">Lista ";
  out += "<input type='radio' name='feedid" + (dropdownlists.length-1) + "radio' value='text'" + (valueString == "text" ? " checked" : "") + ">Text ";
  out += "</p></span>";
  return out;
}

// Adds unit text box
function select_unit(unitString) {
  return "<input type='text' id='feedid" + (dropdownlists.length-1) + "unit' placeholder='Unit (ex. kWh)'" + ((unitString == undefined || unitString === undefined) ? "" : " value='" + unitString + "'") + " style='width: 90px'>";
}

function select_type(typeString){
  switch(typeString){
    case "":
    case "chart":
    case "multi":
      break;
    default:
      typeString = "raw";
  }
  out = "<span class='add-on' style='text-align: right;'><p>";
  out += "<input type='radio' name='feedid" + (dropdownlists.length-1) + "type' value='raw'" + (typeString == "raw" ? " checked" : "") + ">Rådata ";
  out += "<input type='radio' name='feedid" + (dropdownlists.length-1) + "type' value='pie'" + (typeString == "pie" ? " checked" : "") + ">Tårta ";
  out += "<input type='radio' name='feedid" + (dropdownlists.length-1) + "type' value='chart'" + (typeString == "chart" ? " checked" : "") + ">Diagram ";
  out += "<input type='radio' name='feedid" + (dropdownlists.length-1) + "type' value='multi'" + (typeString == "multi" ? " checked" : "") + ">Multi-graf ";
  out += "</p></span>";
  return out;
}

// DateTime picker settings
$('#datetimepicker1').datetimepicker({language: 'en-EN'});
$('#datetimepicker2').datetimepicker({language: 'en-EN', useCurrent: false});

// Adding events to timepickers
$('#datetimepicker1').on("changeDate", function (e) {
  $('#datetimepicker2').data("datetimepicker").setStartDate(e.date);
  $('#request-start').val(parse_timepicker_time($("#export-start").val()));
  check_time();
});

$('#datetimepicker2').on("changeDate", function (e) {
  $('#datetimepicker1').data("datetimepicker").setEndDate(e.date);
  $('#request-end').val(parse_timepicker_time($("#export-end").val()));
  check_time();
});

$('#request-start').on("change", function () {
  x = parse_input_time($('#request-start').val());
  $('#datetimepicker1').data("datetimepicker").setLocalDate(x);
  $('#datetimepicker2').data("datetimepicker").setStartDate(x);
  check_time();
});

$('#request-end').on("change", function () {
  x = parse_input_time($('#request-end').val());
  $('#datetimepicker2').data("datetimepicker").setLocalDate(x);
  $('#datetimepicker1').data("datetimepicker").setEndDate(x);
  check_time();
});

// Only enable report buttons if start time is less than end time
function check_time (){
  if ($('#request-start').val() < $('#request-end').val()) {
    $('#viewbtn').attr('disabled',false);
    $('#viewbtn_newwindow').attr('disabled',false);
    $('#viewbtn_replace').attr('disabled',false);
    $('#viewbtn_error').html("");
    $('#request-interval').val( Math.ceil( ( $('#request-end').val() - $('#request-start').val() ) / 1000) );
  } else {
    $('#viewbtn').attr('disabled',true);
    $('#viewbtn_newwindow').attr('disabled',true);
    $('#viewbtn_replace').attr('disabled',true);
    $('#viewbtn_error').html("Error: Start time greater or equal to end time.");
  }
}

// Initialize timepickers
var now = new Date();
var yesterday = new Date(now.getFullYear(), now.getMonth(), now.getDate()-1, now.getHours(), now.getMinutes(), now.getSeconds());
var picker1 = $('#datetimepicker1').data('datetimepicker');
var picker2 = $('#datetimepicker2').data('datetimepicker');
picker1.setLocalDate(yesterday);
picker2.setLocalDate(now);
picker1.setEndDate(now);
picker2.setStartDate(yesterday);
$('#request-start').val( parse_timepicker_time( $("#export-start").val() ) );
$('#request-end').val( parse_timepicker_time( $("#export-end").val() ) );
$('#request-interval').val(60);
check_time();

// Timepicker date string to number in seconds
function parse_timepicker_time(timestr){
  var tmp = timestr.split(" ");
  if (tmp.length!=2) return false;

  var date = tmp[0].split("-");
  if (date.length!=3) return false;

  var time = tmp[1].split(":");
  if (time.length!=3) return false;

  return new Date(date[0],date[1]-1,date[2],time[0],time[1],time[2],0).getTime() / 1000;
}

// Time number in seconds to date object
function parse_input_time(timenr){
  return new Date(timenr * 1000);
}

// +/- Feed button event functions
function onAddFeedBtnClick(){ // Add new feed at bottom
  draw_options();
}

function onRemFeedBtnClick(){ // Remove bottom most feed
  remove_options();
}

// Adds click events for the two feed buttons
$('#addfeedbtn').click( function(){onAddFeedBtnClick();} );
$('#remfeedbtn').click( function(){onRemFeedBtnClick();} );

// Checks is array contains value
function contains(arr,v){
  /*var i = arr.length;
  while (i--) {
    if (arr[i] === v) return true;
  }
  return false;*/
  // Better method below, requires Javascript 1.6
  return ~arr.indexOf(v);
}

// Filters identical numbers and sorts the array
function sortedUniqueIDs(){
  var feedids = [];
  for (var index in dropdownlists){
    x = $('#'+dropdownlists[index]).val();
    if (!contains(feedids,x)) feedids.push(x);
  }
  return feedids.sort();
}

// Get data
function getData(feedids){
  var feedIn = [], start = $('#request-start').val()*1000, end = $('#request-end').val()*1000, interval = $('#request-interval').val(), skipmissing, limitinterval;
  if ($('#request-skipmissing').is(':checked')) skipmissing = 1; else skipmissing = 0;
  if ($('#request-limitinterval').is(':checked')) limitinterval = 1; else limitinterval = 0;
  for (var index in feedids){
    // var tmp = feed.get_data(feedids[index],start,end,interval,skipmissing,limitinterval);
    if (feedids[index] == null) continue;
    var tmp;
    $.ajax({ url: path+"feed/data.json?"+apikey+"&id="+feedids[index]+"&start="+start+"&end="+end+"&interval="+interval+"&skipmissing="+skipmissing+"&limitinterval="+limitinterval, dataType: 'json', async: false, success: function(data) {tmp = data;} });
    if (tmp && tmp.length != 0) feedIn[feedids[index]] = tmp; // This will create an array with undefined holes
  }
  return feedIn;
}

// Manage data and construct table
function constructTable(dataArr){
  var tableHtml = "";
  // if (dataArr.every(function(v){return v==undefined;})){
  if (dataArr.length != 0 || dataArr.some( function(v){return v!=undefined;} )){
    pieList = [];
    tableHtml += "<table class='table' style='width:auto'>";
    for (var index in dropdownlists){
      var switchcaseType = $('input[name=feedid' + index + 'type]:checked').val();
      var switchcase = $('input[name=feedid' + index + 'radio]:checked').val();
      var unit = $('#feedid'+index+'unit').val();
      var arr = [], arr2 = dataArr[$('#feedid'+index).val()];
      for (var index2 in arr2){
        arr.push( arr2[index2][1] );
      }
      var l = arr.length;
      if(!l){
        continue;
      }
      var arrMax = Math.max(...arr), arrMin = Math.min(...arr), arrMean = (arr.reduce(function(a,b){return a+b;}) / l);
      switch(switchcaseType){
        case "raw":
          pieBool = false;
          tableHtml += "<tr><td" + (switchcase == "list" ? " rowspan='" + l + "'" : "") + (switchcase == "text" ? " colspan='2'><h3>" : "><p>");
          switch(switchcase){
            case "max":
              tableHtml += "Maxvärde</p></td><td><p>" + arrMax + " " + unit;
              break;
            case "min":
              tableHtml += "Minsta värde</p></td><td><p>" + arrMin + " " + unit;
              break;
            case "mean":
              tableHtml += "Genomsnittsvärde</p></td><td><p>" + arrMean + " " + unit;
              break;
            case "median":
              tableHtml += "Medianvärde</p></td><td><p>";
              var half = Math.floor( l / 2 );
              var sorted = arr.sort( function(a,b){return a-b;} );
              if ( l % 2 ) tableHtml += arr[half]; // If rest after dividing by 2, e.g. 1, 3, 5, 7, 9
              else tableHtml += (arr[half-1] + arr[half])/2; // If no rest after dividing by 2, e.g. 2, 4, 6, 8
              tableHtml +=  " " + unit;
              break;
            case "mode":
              var mode = function mode(arr) {
                return arr.reduce( function(current, item) {
                  var val = current.numMapping[item] = (current.numMapping[item] || 0) + 1;
                  if (val > current.greatestFreq) {
                    current.greatestFreq = val;
                    current.mode = item;
                  }
                  return current;
                }, {mode: null, greatestFreq: -Infinity, numMapping: {}}, arr).mode;
              };
              tableHtml += "Modevärde</p></td><td><p>" + mode(arr) + " " + unit;
              break;
            case "range":
              tableHtml += "Omfång</p></td><td><p>" + ( arrMax - arrMin ) + " " + unit;
              break;
            case "difference":
              tableHtml += "Skillnad</p></td><td><p>" + ( arr[l-1] - arr[0] ) + " " + unit;
              break;
            case "list":
              tableHtml += "Lista av värden</p></td>";
              for (var prop in arr){
                tableHtml += "" + (prop == 0 ? "" : "<tr>") + "<td><p>" + arr[prop] + " " + unit + "</p></td></tr>";
              }
              break;
            case "text":
              tableHtml += unit;
              break;
            default:
              tmpText = "Något gick hemskt illa med andra switch case påståendet i funktionen constructTable i filen \"~/Modules/vis/Views/report_view.php\"";
              tableHtml += tmpText;
              console.log(tmpText);
          }
          tableHtml += "" + (switchcase == "list" ? "" : (switchcase == "text" ? "</h3>" : "</p>") + "</td>") + "</tr>";
          break;
        case "pie":
          var i = pieList.length;
          if (pieBool){
            i -= 1;
          } else {
            pieList.push([]);
            tableHtml += "<tr><td colspan='2'><canvas id='pieChart"+i+"' width='400' height='400'></canvas></td></tr>";
          }
          pieBool = true;
          var pieData = false;
          switch(switchcase){
            case "max":
              pieData = arrMax;
              break;
            case "min":
              pieData = arrMin;
              break;
            case "mean":
              pieData = arrMean;
              break;
            case "median":
              var half = Math.floor( l / 2 );
              var sorted = arr.sort( function(a,b){return a-b;} );
              if ( l % 2 ) pieData = arr[half]; // If rest after dividing by 2, e.g. 1, 3, 5, 7, 9
              else pieData = (arr[half-1] + arr[half])/2; // If no rest after dividing by 2, e.g. 2, 4, 6, 8
              break;
            case "mode":
              var mode = function mode(arr) {
                return arr.reduce( function(current, item) {
                  var val = current.numMapping[item] = (current.numMapping[item] || 0) + 1;
                  if (val > current.greatestFreq) {
                    current.greatestFreq = val;
                    current.mode = item;
                  }
                  return current;
                }, {mode: null, greatestFreq: -Infinity, numMapping: {}}, arr).mode;
              };
              pieData = mode(arr);
              break;
            case "range":
              pieData = arrMax - arrMin;
              break;
            case "difference":
              pieData = arr[l-1] - arr[0];
              if (pieData < 0) pieData = 0;
              break;
            default:
              pieData = false;
          }
          if (!!pieData) pieList[i].push([unit,pieData]);
          break;
        case "chart":
          pieBool = false;
          tableHtml += "<tr><td colspan='2'><iframe style='width:580px; height:400px;' frameborder='0' scrolling='no' marginheight='0' marginwidth='0' src='"+path+"vis/rawdata?feedid="+$('#feedid'+index).val()+"&fill=1&colour=edc240&dp=2&scale=1&embed=1&time="+(($('#request-end').val()-$('#request-start').val())*1000)+"'></iframe></td></tr>";
          break;
        case "multi":
          pieBool = false;
          var multiList = [], tmp;
          $.ajax({ url: path+"vis/multigraph/getlist.json?"+apikey, dataType: 'json', async: false, success: function(data) {multiList = data;} });
          if (!!multiList){
            for (var i in multiList) {
              if (multiList[i]['id'] == unit || contains(multiList[i]['name'], unit)) {
                tmp = multiList[i]['id'];
              }
            }
          }
          tableHtml += "<tr><td colspan='2'><iframe style='width:580px; height:400px;' frameborder='0' scrolling='no' marginheight='0' marginwidth='0' src='"+path+"vis/multigraph?mid="+tmp+"&embed=1&"+apikey+"'></iframe></td></tr>";
          break;
        default:
          pieBool = false;
          tmpText = "Något gick hemskt illa med första switch case påståendet i funktionen constructTable i filen \"~/Modules/vis/Views/report_view.php\"";
          tableHtml += tmpText;
          console.log(tmpText);
      }
    }
    tableHtml += "</table>";
  }
  dataArr = []; // Empty array after use
  return tableHtml;
}

// View button click functions
function buttonClick(){
  $('#viewbtn').attr("class", "btn btn-info");
  $('#viewbtn_newwindow').attr("class", "btn btn-primary");
  $('#viewbtn_replace').attr("class", "btn btn-info");
  $('#report').html("<p>Laddar... (Om ingen data anländer så blir knappen röd) (Om knappen blir grön utan att något sker, kontakta utvecklarna)</p>");
  var tablehtml = "";
  tablehtml = constructTable(getData(sortedUniqueIDs()));
  if (!(!!tablehtml)){
  // if (!tablehtml){ // Doesn't seem to work for some reason EDIT: Maybe works?
    $('report').html("<p>Ingen data, dubbelkolla att du har valt rätt tidsram.</p>");
  }
  return tablehtml;
}

function buildChart(newWindow){
  for (var i in pieList){
    if (pieList[i].length > 1){
      var element = !!newWindow ? newWindow.document.querySelector('#pieChart'+i) : $('#pieChart'+i);
      var labels = [], data = [], colors = [];
      for (var z in pieList[i]){
        labels.push(pieList[i][z][0]);
        data.push(pieList[i][z][1]);
        colors.push(colours[z%12+(z/12>=1?1:0)]);
      }
      var pieChart = new Chart(element, {
        type: 'pie',
        data: {
          labels: labels,
          datasets: [{
            data: data,
            backgroundColor: colors,
            hoverBackgroundColor: colors
          }]
        }
      });
    }
  }
}

function viewBtnClick(){
  var tablehtml = "";
  tablehtml = buttonClick();
  if (!!tablehtml){ // Seems to work for some reason
    $('#report').html(tablehtml);
    buildChart();
    $('#viewbtn').attr("class", "btn btn-success");
  }else{
    $('#viewbtn').attr("class", "btn btn-danger");
  }
}

function viewBtnReplaceContentClick(){
  var tablehtml = "";
  tablehtml = buttonClick();
  if (!!tablehtml){ // Seems to work for some reason
    $('body').html(tablehtml);
    $('head').append('<script language="javascript" type="text/javascript" src="' + path + 'Modules/vis/Views/Chart.min.js"></script>');
    buildChart();
  }else{
    $('#viewbtn_replace').attr("class", "btn btn-danger");
  }
}

function viewBtnNewWindowClick(){
  var tablehtml = "";
  tablehtml = buttonClick();
  // Replace these 2 comment with code to open in new window or tab
  if (!!tablehtml) {
    var newWindow = window.open("", "ReportWindow", "left=0,top=0");
    if (!!newWindow){
      newWindow.document.head.innerHTML = '<link href="' + path + 'Lib/bootstrap/css/bootstrap.min.css" rel="stylesheet">'
                                        + '<script type="text/javascript" src="' + path + 'Lib/jquery-1.11.3.min.js"></script>'
                                        + '<script language="javascript" type="text/javascript" src="' + path + 'Modules/vis/Views/Chart.min.js"></script>';
      newWindow.document.body.innerHTML = tablehtml;
      buildChart(newWindow);
      $('#viewbtn_newwindow').attr("class", "btn btn-success");
      return null;
    }
  }
  $('#viewbtn_newwindow').attr("class", "btn btn-danger");
}

// View button click events
$('#viewbtn').click( function(){viewBtnClick();} );
$('#viewbtn_replace').click( function(){viewBtnReplaceContentClick();} );
$('#viewbtn_newwindow').click( function(){viewBtnNewWindowClick();} );

// Show/Hide advanced settings function
function showHideBtnClick(){
  $('#hide0').toggle();
  $('#hide1').toggle();
  $('#hide2').toggle();
}

// Show/Hide Button Click event
$('#showhidebtn').click( function(){showHideBtnClick();} );

$('document').ready(function(){viewBtnClick();});
